#include <LiquidCrystal.h>

/* Rotary encoder read example */
#define ENC_A 14
#define ENC_B 15
#define ENC_PORT PINC
#define PLAY 8

LiquidCrystal lcd(12, 11, 5, 4, 3, 2);

String channelStr[16] = {
  String("channel01"), String("channel02"), String("channel03"), String("channel04"),
  String("channel05"), String("channel06"), String("channel07"), String("channel08"),
  String("channel09"), String("channel10"), String("channel11"), String("channel12"),
  String("channel13"), String("channel14"), String("channel15"), String("channel16")};
  
String name = String("");
String title = String("");

byte numChan = 16;

char inData[100];
byte index = 0;
byte numChar = 23;
byte numCh;

boolean playState;
boolean playPressed;

unsigned long scroll;
int scnm = 0;
int sctl = 0;
int scn = 0;
int sct = 0;
int ndir = 1;
int sdir = 1;

void setup()
{
  /* Setup encoder pins as inputs */
  pinMode(ENC_A, INPUT);
  digitalWrite(ENC_A, HIGH);
  pinMode(ENC_B, INPUT);
  digitalWrite(ENC_B, HIGH);
  
  pinMode(PLAY, INPUT);
  digitalWrite(PLAY, HIGH);
  
  Serial.begin (115200);
  Serial.println("Start");

  // set up the LCD's number of columns and rows:  
  lcd.begin(20, 4);
  // Print a message to the LCD.
  lcd.setCursor(1, 0);
  lcd.print(channelStr[0]);
  lcd.setCursor(0, 0);
  lcd.print(">");
  
  playState = false;
  playPressed = false;
  
  lcd.setCursor(16, 3);
  lcd.print("Stop");

  scroll = millis();
}

void loop()
{
  static uint8_t counter = 0;      //this variable will be changed by encoder input
  static boolean bis = false;
  int8_t tmpdata;
  char c;
  
  if (Serial.available() > 0) {
    if (index < numChar) {
      if (index == 0) {
        c = Serial.read();
        if (c == 'A' || c == 'N' || c == 'S') {
          inData[index++] = c;
        }
      }
      else if (index == 1 && (inData[0] == 'A' || inData[0] == 'N' || inData[0] == 'S')) {
        c = Serial.read();
        if (c == 'B' || c == 'M' || c == 'T') {
          inData[index++] = c;
        }
        else {
          inData[0] = ' ';
          index = 0;
        }
      }
      else if (index == 2 && inData[0] == 'N' && inData[1] == 'M') {
        c = Serial.read();
        inData[index++] = c;        
        numCh = (c - 48) * 10;
      }
      else if (index == 3 && inData[0] == 'N' && inData[1] == 'M') {
        c = Serial.read();
        inData[index++] = c;        
        numCh = numCh + c - 48;
        numChar = numCh;
      }
      else if (index == 2 && inData[0] == 'S' && inData[1] == 'T') {
        c = Serial.read();
        inData[index++] = c;        
        numCh = (c - 48) * 10;
      }
      else if (index == 3 && inData[0] == 'S' && inData[1] == 'T') {
        c = Serial.read();
        inData[index++] = c;        
        numCh = numCh + c - 48;
        numChar = numCh;
      }
      else {
        inData[index++] = Serial.read();
      }
    }
  }
  
  if (index >= numChar) {
    index = 0;
    Serial.flush();
  }

  String tmpStr = String("");
  
  if (index == 0 && inData[0] == 'A' && inData[1] == 'B') {
    for(int i = 0; i < (numChar - 2); i++) {
      if (i > 1) {
        if (inData[i] == '#')
          tmpStr += ' ';
        else
          tmpStr += inData[i];
      }
      inData[i] = ' ';
    }
    int chNum = (inData[numChar - 2] - 48) * 10 + (inData[numChar - 1] - 48);
    channelStr[chNum] = tmpStr;
    if (chNum == (counter % numChan)) {
      lcd.setCursor(1, 0);
      lcd.print(channelStr[chNum]);
      Serial.print(counter, DEC);
      Serial.print('\n');
    }
    lcd.setCursor(8, 3);
    lcd.print("  ");
    lcd.setCursor(8, 3);
    lcd.print(chNum, DEC);
    inData[numChar - 2] = ' ';
    inData[numChar - 1] = ' ';
  }
  else if (index == 0 && inData[0] == 'N' && inData[1] == 'M') {
    for(int i = 0; i < numChar; i++) {
      if (i > 3) {
        tmpStr += inData[i];
      }
      inData[i] = ' ';
    }
    lcd.setCursor(0, 1);
    lcd.print("                    ");
    lcd.setCursor(0, 1);
    tmpStr.trim();
    name = tmpStr;
    lcd.print(name.substring(0, 20));
    numChar = 23;
  }
  else if (index == 0 && inData[0] == 'S' && inData[1] == 'T') {
    for(int i = 0; i < numChar; i++) {
      if (i > 3) {
        tmpStr += inData[i];
      }
      inData[i] = ' ';
    }
    lcd.setCursor(0, 2);
    lcd.print("                    ");
    lcd.setCursor(0, 2);
    tmpStr.trim();
    title = tmpStr;
    lcd.print(title.substring(0, 20));
    numChar = 23;
    sctl = 0;
    sct = 0;
    sdir = 1;
  }

  if (millis() > scroll) {
    scroll = scroll + 200;
    
    int nmlen = name.length();
    int tllen = title.length();
    
    if (nmlen > 20) {
      if (scnm >= 0 && scnm <= nmlen - 20) {
        lcd.setCursor(0, 1);
        lcd.print(name.substring(scnm, 20 + scnm));
        if (scnm == 0 && scn < 10) {
          scn++;
          ndir = 1;
        }
        else if (scnm == (nmlen - 20) && scn < 10) {
          scn++;
          ndir = -1;
        }
        else
        {
          scnm += ndir;
          scn = 0;
        }
      }
      //else {
        //scnm = 0;
      //}
    }
    
    if (tllen > 20) {
      if (sctl >= 0 && sctl <= tllen - 20) {
        lcd.setCursor(0, 2);
        lcd.print(title.substring(sctl, 20 + sctl));
        if (sctl == 0 && sct < 10) {
          sct++;
          sdir = 1;
        }
        else if (sctl == (tllen - 20) && sct < 10) {
          sct++;
          sdir = -1;
        }
        else
        {
          sctl += sdir;
          sct = 0;
        }
      }
      //else {
        //sctl = 0;
      //}
    }
  }
  
  read_button();
  
  tmpdata = read_encoder();
  delay(1);
  if (tmpdata != 0) {
    bis = !bis;
    if (bis) {
      counter += tmpdata;

      //Serial.print("Counter value: ");
      Serial.print((counter % 16), DEC);
      Serial.print('\n');

      lcd.setCursor(0, 0);
      lcd.print(" ");
      lcd.setCursor(1, 0);
      lcd.print("                   ");
      lcd.setCursor(1, 0);
      lcd.print(channelStr[counter % numChan]);
      lcd.setCursor(0, 0);
      lcd.print(">");

      lcd.setCursor(12, 3);
      lcd.print("   ");
      lcd.setCursor(12, 3);
      lcd.print(counter, DEC);
      
      scnm = 0;
      sctl = 0;
      scn = 0;
      sct = 0;
      ndir = 1;
      sdir = 1;
      name = "";
      title = "";
    }
  }
}

void read_button()
{
  if (digitalRead(PLAY) == LOW && playPressed == false)
  {
    playPressed = true;
    playState = !playState;
    scnm = 0;
    sctl = 0;
    scn = 0;
    sct = 0;
    ndir = 1;
    sdir = 1;
    name = "";
    title = "";
    lcd.setCursor(16, 3);
    if (playState)
    {
      lcd.print("Play");
      Serial.print(100, DEC);
      Serial.print('\n');
    }
    else
    {
      lcd.print("Stop");
      Serial.print(101, DEC);
      Serial.print('\n');
    }
  }
  else if (playPressed == true && digitalRead(PLAY) == HIGH)
  {
    playPressed = false;
  }
}

/* returns change in encoder state (-1,0,1) */
int8_t read_encoder()
{
  static int8_t enc_states[] = {
    0,-1,1,0,1,0,0,-1,-1,0,0,1,0,1,-1,0    };
  static uint8_t old_AB = 0;

  old_AB <<= 2;                   //remember previous state
  old_AB |= ( ENC_PORT & 0x03 );  //add current state
  return (enc_states[( old_AB & 0x0f )]);
}

